import 'dart:convert';

class Catalog {
  final String catalogId;
  final String catalogName;

  Catalog({
    required this.catalogId,
    required this.catalogName,
  });

  Catalog copyWith({
    String? catalogId,
    String? catalogName,
  }) =>
      Catalog(
        catalogId: catalogId ?? this.catalogId,
        catalogName: catalogName ?? this.catalogName,
      );

  factory Catalog.fromRawJson(String str) => Catalog.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory Catalog.fromJson(Map<String, dynamic> json) => Catalog(
        catalogId: json["catalogId"],
        catalogName: json["catalogName"],
      );

  Map<String, dynamic> toJson() => {
        "catalogId": catalogId,
        "catalogName": catalogName,
      };
}
