import 'dart:convert';

class InboxItem {
  String buttonAppUrl2;
  String buttonAppUrl1;
  String content;
  DateTime lastUpdated;
  String appUrl;
  String itemId;
  String heading;
  DateTime dateCreated;
  String imageUrl;
  String buttonLabel1;
  List<String> catalogIds;
  String buttonLabel2;
  String launchUrl;
  String buttonLaunchUrl1;
  String buttonLaunchUrl2;
  String lookupType;
  String templateId;
  int status;
  String trackingUrl;

  InboxItem({
    required this.buttonAppUrl2,
    required this.buttonAppUrl1,
    required this.content,
    required this.lastUpdated,
    required this.appUrl,
    required this.itemId,
    required this.heading,
    required this.dateCreated,
    required this.imageUrl,
    required this.buttonLabel1,
    required this.catalogIds,
    required this.buttonLabel2,
    required this.launchUrl,
    required this.buttonLaunchUrl1,
    required this.buttonLaunchUrl2,
    required this.lookupType,
    required this.templateId,
    required this.status,
    required this.trackingUrl,
  });

  InboxItem copyWith({
    String? buttonAppUrl2,
    String? buttonAppUrl1,
    String? content,
    DateTime? lastUpdated,
    String? appUrl,
    String? itemId,
    String? heading,
    DateTime? dateCreated,
    String? imageUrl,
    String? buttonLabel1,
    List<String>? catalogIds,
    String? buttonLabel2,
    String? launchUrl,
    String? buttonLaunchUrl1,
    String? buttonLaunchUrl2,
    String? lookupType,
    String? templateId,
    int? status,
    String? trackingUrl,
  }) =>
      InboxItem(
        buttonAppUrl2: buttonAppUrl2 ?? this.buttonAppUrl2,
        buttonAppUrl1: buttonAppUrl1 ?? this.buttonAppUrl1,
        content: content ?? this.content,
        lastUpdated: lastUpdated ?? this.lastUpdated,
        appUrl: appUrl ?? this.appUrl,
        itemId: itemId ?? this.itemId,
        heading: heading ?? this.heading,
        dateCreated: dateCreated ?? this.dateCreated,
        imageUrl: imageUrl ?? this.imageUrl,
        buttonLabel1: buttonLabel1 ?? this.buttonLabel1,
        catalogIds: catalogIds ?? this.catalogIds,
        buttonLabel2: buttonLabel2 ?? this.buttonLabel2,
        launchUrl: launchUrl ?? this.launchUrl,
        buttonLaunchUrl1: buttonLaunchUrl1 ?? this.buttonLaunchUrl1,
        buttonLaunchUrl2: buttonLaunchUrl2 ?? this.buttonLaunchUrl2,
        lookupType: lookupType ?? this.lookupType,
        templateId: templateId ?? this.templateId,
        status: status ?? this.status,
        trackingUrl: trackingUrl ?? this.trackingUrl,
      );

  factory InboxItem.fromRawJson(String str) =>
      InboxItem.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory InboxItem.fromJson(Map<String, dynamic> json) => InboxItem(
        buttonAppUrl2: json["button_app_url_2"] ?? "",
        buttonAppUrl1: json["button_app_url_1"] ?? "",
        content: json["content"] ?? "",
        lastUpdated: DateTime.parse(json["last_updated"]),
        appUrl: json["app_url"] ?? "",
        itemId: json["item_id"] ?? "",
        heading: json["heading"] ?? "",
        dateCreated: DateTime.parse(json["date_created"]),
        imageUrl: json["image_url"] ?? "",
        buttonLabel1: json["button_label_1"],
        catalogIds:
            List<String>.from(jsonDecode(json["catalog_ids"]).map((x) => x)),
        buttonLabel2: json["button_label_2"] ?? "",
        launchUrl: json["launch_url"] ?? "",
        buttonLaunchUrl1: json["button_launch_url_1"] ?? "",
        buttonLaunchUrl2: json["button_launch_url_2"] ?? "",
        lookupType: json["lookup_type"] ?? "",
        templateId: json["template_id"] ?? "",
        status: int.parse(json["status"]),
        trackingUrl: json["tracking_url"] ?? "",
      );

  Map<String, dynamic> toJson() => {
        "button_app_url_2": buttonAppUrl2,
        "button_app_url_1": buttonAppUrl1,
        "content": content,
        "last_updated": lastUpdated.toIso8601String(),
        "app_url": appUrl,
        "item_id": itemId,
        "heading": heading,
        "date_created": dateCreated.toIso8601String(),
        "image_url": imageUrl,
        "button_label_1": buttonLabel1,
        "catalog_ids": List<dynamic>.from(catalogIds.map((x) => x)),
        "button_label_2": buttonLabel2,
        "launch_url": launchUrl,
        "button_launch_url_1": buttonLaunchUrl1,
        "button_launch_url_2": buttonLaunchUrl2,
        "template_id": templateId,
        "status": status,
        "tracking_url": trackingUrl,
      };
}
